/* 
 * This file is part of the Echo2 Table Extension (hereinafter "ETE").
 * Copyright (C) 2002-2005 NextApp, Inc.
 *
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 */

package echopointng.table;
import java.util.LinkedList;
import java.util.List;

import nextapp.echo2.app.table.TableColumnModel;

/**
 * The default implementation for the <code>PageableTableModel</code>
 * and <code>SortableTableModel</code> interfaces.
 * <p>
 * This uses a linked list for the data entries and is unsuitable for
 * very large data sets.
 * 
 * @author Jason Dalton
 *  
 */
public class DefaultPageableSortableTableModel extends
        DefaultSortableTableModel implements PageableTableModel {

    public static final int DEFAULT_ROWS_PER_PAGE = 25;
    public static final int DEFAULT_INITAL_PAGE_INDEX = 0;
    
    private int currentPage = DEFAULT_INITAL_PAGE_INDEX;
    private int rowsPerPage = DEFAULT_ROWS_PER_PAGE;
    
    private List data = new LinkedList();
    
    public DefaultPageableSortableTableModel(TableColumnModel columnModel) {
        super(columnModel);
    }
    
    /** 
     * @see nextapp.echo2.app.table.DefaultTableModel#setValueAt(java.lang.Object, int, int)
     */
    public void setValueAt(Object newValue, int column, int row) {
        if (data.size() < (row+1)){
            data.add(row,new LinkedList());
        }
        List valueList = (List) data.get(row);
        valueList.add(column,newValue);
        fireTableCellUpdated(column,row);
    }
    
    /**
     * @see nextapp.echo2.app.table.TableModel#getValueAt(int, int)
     */
    public Object getValueAt(int column, int row) {
        int normalizedRow = currentPage * rowsPerPage + row;
        List valueList = (List) data.get(normalizedRow);
        if (valueList != null){
            return valueList.get(column);
        } else {
            return null;
        }
    }
    
    /**
     * Returns a List of Lists representing the table's data
     */
    protected List getRows() {
        return data;
    }

    /**
     * Sets the List of Lists representing the table's data.   
     * This implementation makes use of the fact that the 
     * super implementation modifies this List in place 
     * as needed, so setting it is unnecessary.
     */
    protected void setRows(List rows) {
        fireTableDataChanged();
    }
    
    /**
     * @see nextapp.echo2.app.table.TableModel#getRowCount()
     */
    public int getRowCount() {
        int viewableCount = data.size() - (currentPage * rowsPerPage);
        if (rowsPerPage > viewableCount) {
            return viewableCount;
        } else {
            return rowsPerPage;
        }
    }
    
    /**
     * @see echopointng.table.PageableTableModel#setCurrentPage(int)
     */
    public void setCurrentPage(int page) {
        currentPage = page;
        fireTableDataChanged();
    }

    /**
     * @see echopointng.table.PageableTableModel#getCurrentPage()
     */
    public int getCurrentPage() {
        return currentPage;
    }

    /**
     * @see echopointng.table.PageableTableModel#setRowsPerPage(int)
     */
    public void setRowsPerPage(int rows) {
        rowsPerPage = rows;
        fireTableDataChanged();
    }

    /**
     * @see echopointng.table.PageableTableModel#getRowsPerPage()
     */
    public int getRowsPerPage() {
        return rowsPerPage;
    }

    /**
     * @see echopointng.table.PageableTableModel#getTotalRows()
     */
    public int getTotalRows() {
        return data.size();
    }
    
    /**
     * @see echopointng.table.PageableTableModel#getTotalPages()
     */
    public int getTotalPages() {
        return (getTotalRows() / getRowsPerPage());
    }

}
